<!--单选题-->
<style>

</style>
<template>
  <div class="singleQuestion">
    <table v-if="data&&data.length>0">
      <tr v-for="(item,index) in data">
        <td>
          <el-checkbox v-model="item.IsAnswer" @change="ChangeItem(item)">{{item.Name}}</el-checkbox>
        </td>
        <td>
          <UeEditor v-model="item.Content" :config="config"></UeEditor>
        </td>
        <td>
          <a style="cursor:pointer;" @click="deleteOpion(index)">删除</a>
        </td>
      </tr>
      <tfoot>
        <tr>
          <td colspan="3">
            <a style="cursor:pointer;" @click="addOption()">添加选项</a>
          </td>
        </tr>
      </tfoot>
    </table>
  </div>
</template>
<script>
  import {
    getOptionList, //获取选择标签【A,B,C,D....】
  } from '../../api/question/questionconfig'
  import UeEditor from '../editor/UeEditor'
  export default {
    props: {
      questionData: {
        type: Array,
      }
    },
    components: {
      UeEditor
    },
    data() {
      return {
        data: this.questionData,
        config: {
          initialFrameWidth: null,
          initialFrameHeight: 80,
        },
        optionTitleList: [],
      };
    },
    created() {
      this.initConfig();
    },
    methods: {
      initConfig() {
        this.optionTitleList = getOptionList();
      },
      //删除选项
      deleteOpion(index) {
        this.data.splice(index, 1);
        this.calcOptionTitle();
      },
      //新增选项
      addOption() {
        if (this.data.length < 7) {
          this.data.push({
            Name: "",
            Content: "",
            IsAnswer: false
          });
          this.calcOptionTitle()
        } else {
          this.$q.notify({
            type: 'warning',
            position: 'center',
            timeout: 1500,
            message: `最多只能添加7个选项`
          })
          return
        }
      },
      //重新计算选择Title[A,B,C,D....]
      calcOptionTitle() {
        if (this.data && this.data.length > 0) {
          this.data.forEach((item, index) => {
            item.Name = this.optionTitleList[index];
          })
        }
      },
      //返回数据到父组件
      returnDataToParent() {
        this.$emit('getChild', this.data);
      },
      ChangeItem(item) {
        if (this.data && this.data.length > 0) {
          this.data.forEach(item => {
            item.IsAnswer = false;
          })
        }
        item.IsAnswer = true;
      },
    },
    mounted() {

    },
    watch: {
      data: {
        handler(newValue) {
          this.returnDataToParent();
        },
        deep: true
      },
    }
  };

</script>
